unit LisaaButton;
{ Tehdn malliksi uusi komponentti TLisaaButton, joka osaa
  list valitun Laskurin arvoa propertyn Lisays mrll.

  Otetaan huomioon mys se, ett Laskuri voidaan poistaa
  ennen buttonia.

  Vesa Lappalainen 4.10.2001

  Notification-metodiin listty RemoveFreeNotification
  MN / 17.4.2004
}


interface
uses  Classes,
{$ifdef CLX}
  QStdCtrls,
{$else}
  StdCtrls,
{$endif}
  Laskuri;

type
  TLisaaButton = class(TButton)
  private
    FLaskuri: TLaskuri;
    FLisays: integer;
  protected
    procedure SetLaskuri(const Value: TLaskuri); virtual;
  public
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Click; override;
    constructor Create(AOwner:TComponent); override; 
  published
    property Laskuri : TLaskuri read FLaskuri write SetLaskuri;
    property Lisays : integer read FLisays write FLisays default 1;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('GKOCLX', [TLisaaButton]);
end;


{ TLisaaButton }

procedure TLisaaButton.Click;
begin
  inherited;
  if ( not Assigned(Laskuri) ) then exit;
//  if ( Laskuri = nil ) then exit;

  Laskuri.Inc(Lisays);
end;


(* Huom. Set- ja notification metodienn
    perusrakenne on sama _kaikille_
   yksinkertaisille komponenttipropertyille, joiden
   muistinhallinnasta komponentti _ei_ vastaa itse.
   Rakenne kannattaa kopioida muistiin tai list
   Delphin code templateksi
  (tools->editor options->source options->
    edit code templates      *)
procedure TLisaaButton.SetLaskuri(const Value: TLaskuri);
begin
  if Value = FLaskuri then Exit;
      // tai: Flaskuri <> nil
  if Assigned(Flaskuri) then Flaskuri.RemoveFreeNotification(self);
  FLaskuri := Value;
  if Assigned(Value) then Value.FreeNotification(Self);
end;

// ks. SetLaskuri
procedure TLisaaButton.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited; // Notification(AComponent, Operation);
  if (Operation = opRemove) then begin
    if (AComponent = Laskuri) then Laskuri := nil;
    // else if (AComponent = ...) ... := nil
    // else ...
  end; 
end;


constructor TLisaaButton.Create(AOwner: TComponent);
begin
  inherited;
  Lisays := 1; 
end;

end.
