unit laskuri;
{ Tehdn malliksi uusi komponentti TLaskuri, joka on kuten TLabel,
  mutta siin pidetn kokonaislukuarvoa oikeassa reunassa, sinisell pohjalla
  kentn leveys silytten (oletuksena) ja siin on lisksi lisys-metodi.
  Caption-ominaisuuden muuttaminen kelpuuttaa vain kokonaisluvut ja Caption
  on aina synkronissa Count-arvon kanssa.

  Vesa Lappalainen 26.8.1996

  Muutokset 15.9.1997/vl
    + tarkistettu toiminta mys Delphi 3.0:ssa ja kirjoittu vastaava
      komponenttikirjaston "kyttohje"

  Muutokset 11.10.1998/vl
    + tarkistettu toiminta mys Delphi 4.0:ssa ja kirjoittu vastaava
      komponenttikirjaston "kyttohje".  Value vaihdettu Count, koska
      luokkatydennin kytt Value:ta lokaalina parametrin

  "Kirjastoa" voidaan testata ennen varsinaiseen komponenttikirjastoon
  lismist seuraavasti:
    1) Tee uusi projekti, lis uses-osaan laskuri
    2) Formin private osaan laita esim:
          lask : TLaskuri
    3) Formin alustukseen kirjoitat:
          lask := TLaskuri.Create(self);
          lask.Parent := self;
          lask.SetBounds(20,20,50,lask.Height);
    4) Lis vaikkapa nappula, jonka painamisen koodiksi kirjoitat:
          lask.Inc(1);

  Komponentti voidaan list kirjastoon seuraavasti (Delphi 3.0):
    1) Kopioi laskuri.dcr (tai tee uusi: Tools/Image Editor) samaan paikkaan
       kuin laskuri.pas (tnne on tehty komponenttisivulle
       tuleva bittikartta TLASKURI, 24x24, Huom!  nimi isolla
       Pit olla nkjn oma .dcr eri Delphi versioille!).
    2) Valitse Component/Install Component
    3) a) Jos haluamasi kirjasto on jo olemassa, valitse "Into Existing package"
          ja sitten Yes
       b) Jos kirjastoa ei ole, valitse "Into New Package", kirjoita
          kirjaston nimi (esim. lask) ja kuvaus ja OK
    4) Jos kirjastoa (Package) pit korjailla, valitse esim.
       Component/Install Packages
       ja valitse kirjasto ja Edit.  Korjausten jlkeen paina Compile ja
       tarvittaessa Install.  Voit mys avata tiedoston lask.dpk.

  Kirjoittamisvinkki Delphi 4.0:
    1) Lis ensin rivi:  property Count : integer;
    2) Paina Shift+Ctrl+C  (Complete Class at Cursor)
    3) Tydenn syntynyt SetCount -metodi.
    4) Kirjoita rivi: constructor Create(...
    5) Paina Shift+Ctrl+C
    6) Tydenn Create-metodi
    7) Tydenn puuttuvat virtual -mritykset

  Komponentti voidaan list kirjastoon seuraavasti (Delphi 1.0 ja 2.0):
    1) Knn tm tiedosto (vaikka jonkin projekti osana), esim. edellisen
       testin knns riitt
    2) Kopioi laskuri.dcu sinne kirjastoon, jossa sinulla on komponentit
       (ks. vaikka Components/Install/Search Path)
    3) Kopioi laskuri.dcr samaan paikkaan (tnne on tehty komponenttisivulle
       tuleva bittikartta TLASKURI, 24x24, Huom!  nimi isolla
       Pit olla nkjn oma .dcr Delphi 1.0:lle ja Delphi 2.0:lle!).
    4) Valitse Components/Install/Add ja kirjoita Laskuri ja OK OK
       (Delphi 1.0:ssa Options/Install Components/....)
    5) Jos jatkossa havaitset komponentissa, riitt korjausten jlkeen
       Rebuild Library


  Tehtvi (komponentit voi list thn samaan tiedostoon):
    1) Tee uusi komponentti TLisaaButton, jolla on ominaisuutena
       Laskuri : TLaskuri  - laskuri, jonka arvoa listn aina
                             kun nappia painetaan
       Lisays  : Integer   - paljollako laskuria listn
    2) Tee autolaskuri em. komponenteilla niin, ett tarvitsee
       kirjoittaa vain yksi rivi koodia: Nollaa-nappulalle
    3) Tee viel komponentti TNollaa, joka nollaa kaikki samalla
       lomakkeella olevat laskurit (ks. ComponentCount ja Components).
    4) Tee autolaskuri kirjoittamatta rivikn koodia.  Jos
       listn uusi laskuri-lis -pari, niin taritaanko vielkn
       koodia?
    5)*Modifioi TNollaa- komponettia siten, ett sille voidaan antaa
       ominaisuutena kaikki komponentit, jotka halutaan nollata.
    6) Peri TLaskuri panelista ja aseta oletuksena sopivat reunukset plle.
    }

interface

uses Classes,
{$ifdef CLX}
  QControls, QGraphics,  QStdCtrls,
{$else}  // VCL
  Controls,   Graphics,   StdCtrls,
{$endif}
  SysUtils;

type
  TLaskuri = class;

  TLaskuriEvent = procedure (sender:TLaskuri; diff:integer) of object;

  TLaskuri = class(TLabel)
  private
    FCount : integer;
    FOnChange: TLaskuriEvent;
    function GetCaption: string;
    procedure SetCaption(const Value: string);
  protected
    procedure SetCount(const Value: integer);  virtual;
  public
    constructor Create(AOwner:TComponent); override;
    function Inc(i:integer) : integer;     virtual;
  published  { Published declarations } { Yleens vain ominaisuudet.           }
    { Ominaisuuksiin ilmoitetaan miten niit luetaan ja miten asetetetaan sek }
    { mahdollinen oletusarvo. Oletusarvo on ainoastaan ohje siit, ettei       }
    { arvoa talleteta resurssitiedostoon, jos arvo on sama kuin oletus.        }
    { Luku/kirjoitusohje voi olla saman tyyppisen attribuutin nimi tai         }
    { aliohjelma asettamiseen ja funktio lukemiseen                            }
    property Count:integer read FCount write SetCount default 0;
    property Caption:string read GetCaption write SetCaption stored false;
    { Seuraavat ominaisuudet islt, ainoastaan oletusarvot erilaiset          }
    property Alignment        default taRightJustify;
    property AutoSize         default False;
    property Color            default clAqua;
    property ParentColor      default false;
    { Kaikki muut isn ominaisuudet tulee sellaisenaan                         }
    property OnChange : TLaskuriEvent read FOnChange write FOnChange;
  end;

procedure Register;

implementation



constructor TLaskuri.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);            { Muista tm!!! Muuten ky huonosti!!!}
  Count := 0;                          { Defaulteissa luvatut arvot:          }
  Alignment := taRightJustify;
  Color := clAqua;
  ParentColor := False;
  Font.Height := -32;
  Font.Style := [fsBold];
  AutoSize := False;
end;


procedure TLaskuri.SetCount(const Value: integer);
var diff : integer;
begin
  diff := Value - Count;
  FCount := Value;
  inherited Caption := IntToStr(Count)+' '; { Vlilynti lop. on paremman nk. }
  if ( Assigned(OnChange) ) then OnChange(self,diff);
end;


function TLaskuri.Inc(i:integer) : integer;
begin
  Count := Count + i;
  Result := Count;
end;




procedure Register;
{ Komponentit pit rekisterid komponenttisivulle }
begin
  RegisterComponents('GKOCLX', [TLaskuri]);
end;
    
function TLaskuri.GetCaption: string;
begin
  Result := Trim(inherited Caption); { Varo rekursiota!!! }
end;

procedure TLaskuri.SetCaption(const Value: string);
begin
  Count := StrToIntDef(Trim(Value),0);
end;


end.
